HDU 3342 Legal or Not (最短路 拓扑排序?)

Legal or Not

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 6580    Accepted Submission(s): 3088


Problem Description
ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many "holy cows" like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost "master", and Lost will have a nice "prentice". By and by, there are many pairs of "master and prentice". But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

We all know a master can have many prentices and a prentice may have a lot of masters too, it's legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian's master and, at the same time, 3xian is HH's master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not. 

Please note that the "master and prentice" relation is transitive. It means that if A is B's master ans B is C's master, then A is C's master.
 
Input
The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y's master and y is x's prentice. The input is terminated by N = 0.
TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,..., N-1). We use their numbers instead of their names.
 
Output
For each test case, print in one line the judgement of the messy relationship.
If it is legal, output "YES", otherwise "NO".
 
Sample Input
3 2 0 1 1 2 2 2 0 1 1 0 0 0
 
Sample Output
YES NO
 
Author
QiuQiu@NJFU
 
Source
 
Recommend
lcy   |   We have carefully selected several similar problems for you:  1285 2647 3333 3339 3341
 
看题解有的说拓扑排序? 把我吓到了,  但是还是有一种简单的解法  Floyd 跑一遍就行了
如果一条路mat[i][j] 和 mat[j][i] 都是不是INF, 就说明NO了
#include<algorithm>
#include<stdio.h>
#include<iostream>

using namespace std;
#define N 112345678
#define M 111
#define INF 0x3f3f3f3f

int n,m,a,b,x,y,t;
int mat[M][M];

void init()
{
    for(int i = 0; i < M; i++)
    for(int j = 0; j < M; j++)
        mat[i][j] = INF;

}
int main()
{
    while(cin>>n>>m && n)
    {
        init();
        bool flag = true;
        while(m--)
        {
            scanf("%d %d", &x, &y);
            mat[x][y] = 1;
        }
        for(int k = 0; k < n; k++)
            for(int i = 0; i < n; i++)
            if(mat[i][k] != INF) // 加这个此题 会大大节约时间 !  加了93MS 不加748MS
            for(int j = 0; j < n; j++)
                if(mat[i][j] > mat[i][k] + mat[k][j])
                    mat[i][j] = mat[i][k] + mat[k][j];


        for(int i = 0; i < n; i++)
            for(int j = 0; j < n; j++)
                if(i != j)
                if(mat[i][j] != INF && mat[j][i] != INF)
                    {
                        flag = false;
                        break;
                    }

        if(!flag)
            puts("NO");

        else
            puts("YES");

    }
    return 0;
}

以后Floyd 超时可以试试加上这句代码

 for(int k = 0; k < n; k++)
            for(int i = 0; i < n; i++)
            if(mat[i][k] != INF) // 加这个此题 会大大节约时间 !  加了93MS 不加748MS
            for(int j = 0; j < n; j++)

原文地址:https://www.cnblogs.com/wmxl/p/5293912.html